%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   Kristian L. Jenssen & Kaan H. Yabar
%   Engineering Cybernetics - May.2011 
%
%   Linear prediction 
%   Input: Data containing quaternions, pointer pointing to start element
%   Output: Estimated quaternion based on linear prediction
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function q = lin_pre(data,pek)
    n=length(data(1,:));
    sum_data=zeros(4,1);
    sum_time=0;
    sum_time_data=zeros(4,1);
    sum_time_quad=0;
    for o=pek:1:n+pek
        in=mod(o,10)+1;   
        sum_data=sum_data+data(:,in);
        sum_time=sum_time+0.01;
        sum_time_data=sum_time_data+data(:,in)*(o-pek)*0.01;
        sum_time_quad=sum_time_quad+((o-pek)*0.01)^2;
    end
    num=n*sum_time_quad-sum_time^2;
    b_0=(n*sum_time_data-sum_time*sum_data)/num;
    b_1=sum_data*sum_time_quad-sum_time*sum_time_data/num;
q=b_0*(n+1)+b_1; 

