%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%           Kaan H. Yabar
%           11.09.2010
%           
%           CALCULATION OF THE OPTIMAL VALUE
%
%           Input to the fuction is matrix A and vector g for system having
%           the form :
%           0.5x'Ax+g'x
%           
%           Output is optimal lambda (l)
%           Minimum of function can be found by:
%           inv(A+lI)g where I is identity matrix
%
%       
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [l] = optimal_lambda(A,g)

%choose termination radius
eps=0.000001;
%Every NxN real symmetric matrix has N linear independent real
%eigenvectors. A real symmetric matrix can be decomposed as U*DU'=A
[U D] = eig(A);
%Find minimum eigenvector and multiply by -1 to find algorithm start value
eigen=eig(A);
minimum=min(eigen)*(-1) + eps;
g=U'*g;

%Find a lambda where x(lambda) is less than zero: set final=lambda
run=1;
step=1;
lastvalue = 0;
while(run==1)
    lambda=minimum + step;
    x=(g(1)^2/(lambda+eigen(1))^2)+(g(2)^2/(lambda+eigen(2))^2)+(g(3)^2/(lambda+eigen(3))^2)+(g(4)^2/(lambda+eigen(4))^2)-1;
    if(x>0)
        step=step*2;
        lastvalue = lambda;
    else
        run=0;
        final = lambda;
    end
end

%Using binary search, find optimal value
run=1;
start = lastvalue;
%final = minimum+step;
number_of_itirations=0;
mid=start+((final-start)/2);
while(run==1)
    mid=start+((final-start)/2);
    x=(g(1)^2/(mid+eigen(1))^2)+(g(2)^2/(mid+eigen(2))^2)+(g(3)^2/(mid+eigen(3))^2)+(g(4)^2/(mid+eigen(4))^2)-1;
    if(x>-eps && x<eps)
        run=0;
        l=mid; %optimal lambda
    elseif(x>0)
        start=mid;
    else 
        final=mid;
    end
    number_of_itirations=number_of_itirations+1;
    if(number_of_itirations>1000000)
        run=0;
        l=minimum;
        run = 0;
        %'No solution'
        %terminate-could not find solution
    end
   
end
number_of_itirations;
       
        
        
           